if Lib_GPI == nil then
	Lib_GPI = {}
end
if Lib_GPI.ToolBox==nil or Lib_GPI.ToolBox_Ver<105 then
Lib_GPI.ToolBox_Ver=105
Lib_GPI.IconClass={
  ["WARRIOR"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:0:64:0:64|t",
  ["MAGE"]=		"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:64:128:0:64|t",
  ["ROGUE"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:128:196:0:64|t",
  ["DRUID"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:196:256:0:64|t",
  ["HUNTER"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:0:64:64:128|t",
  ["SHAMAN"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:64:128:64:128|t",
  ["PRIEST"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:128:196:64:128|t",
  ["WARLOCK"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:196:256:64:128|t",
  ["PALADIN"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:0:0:0:0:256:256:0:64:128:196|t",
  }
Lib_GPI.IconClassBig={
  ["WARRIOR"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:0:64:0:64|t",
  ["MAGE"]=		"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:64:128:0:64|t",
  ["ROGUE"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:128:196:0:64|t",
  ["DRUID"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:196:256:0:64|t",
  ["HUNTER"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:0:64:64:128|t",
  ["SHAMAN"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:64:128:64:128|t",
  ["PRIEST"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:128:196:64:128|t",
  ["WARLOCK"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:196:256:64:128|t",
  ["PALADIN"]=	"|TInterface\\WorldStateFrame\\ICONS-CLASSES:18:18:-4:4:256:256:0:64:128:196|t",
  }  
Lib_GPI.Classes={ "WARRIOR", "MAGE", "ROGUE", "DRUID", "HUNTER", "SHAMAN", "PRIEST", "WARLOCK", "PALADIN" }

Lib_GPI._tableAccents = {
    [""] = "A", [""] = "A", [""] = "A", [""] = "A", [""] = "Ae", [""] = "A",
	[""] = "AE", [""] = "C", [""] = "E", [""] = "E", [""] = "E", [""] = "E", 
	[""] = "I", [""] = "I", [""] = "I", [""] = "I", [""] = "D", [""] = "N", 
	[""] = "O", [""] = "O", [""] = "O", [""] = "O", [""] = "Oe", [""] = "O", 
	[""] = "U", [""] = "U", [""] = "U", [""] = "Ue", [""] = "Y", [""] = "P", 
	[""] = "s", [""] = "a", [""] = "a", [""] = "a", [""] = "a", [""] = "ae", 
	[""] = "a", [""] = "ae", [""] = "c", [""] = "e", [""] = "e", [""] = "e", 
	[""] = "e", [""] = "i", [""] = "i", [""] = "i", [""] = "i", [""] = "eth", 
	[""] = "n", [""] = "o", [""] = "o", [""] = "o", [""] = "o", [""] = "oe", 
	[""] = "o", [""] = "u", [""] = "u", [""] = "u", [""] = "ue", [""] = "y", 
	[""] = "p", [""] = "y", [""] = "ss",
	}




function Lib_GPI._Merge(t1,t2,...)
	if t2~=nil then 
		for i,v in pairs(t2) do 
			t1[i]=v
		end
		return Lib_GPI._Merge(t1,...)
	end
	return t1
end

function Lib_GPI._iMerge(t1,t2,...)
	if t2~=nil then 
		for i,v in ipairs(t2) do 
			if tContains(t1,v)==false then
				tinsert(t1,v)
			end
		end
		return Lib_GPI._iMerge(t1,...)
	end
	return t1
end
 

Lib_GPI._SizingStop=function(self,button)
	self:GetParent():StopMovingOrSizing()
	if self.GPI_DoStop then self.GPI_DoStop(self:GetParent()) end
end

Lib_GPI._SizingStart=function(self,button)
	self:GetParent():StartSizing(self.GPI_SIZETYPE)
	if self.GPI_DoStart then self.GPI_DoStart(self:GetParent()) end
end

Lib_GPI._SizingEnter=function(self)
	if not GetCursorInfo() then
		self.GPI_Lib._ResizeCursor:Show()
		self.GPI_Lib._ResizeCursor.Texture:SetTexture(self.GPI_Cursor)
	end
end

Lib_GPI._SizingLeave=function(self,button)
	self.GPI_Lib._ResizeCursor:Hide()	
end

Lib_GPI._CreateSizeBorder=function(lib,frame,name,a1,x1,y1,a2,x2,y2,cursor,OnStart,OnStop) 
	local FrameSizeBorder
	--FrameSizeBorder=CreateFrame("Button",name.."_size_"..name,frame,"UIPanelButtonTemplate")
	FrameSizeBorder=CreateFrame("Frame",frame:GetName().."_size_"..name,frame)
	FrameSizeBorder:SetPoint("TOPLEFT", frame, a1, x1, y1)
	FrameSizeBorder:SetPoint("BOTTOMRIGHT", frame, a2, x2,y2 )
	FrameSizeBorder.GPI_SIZETYPE=name
	FrameSizeBorder.GPI_Cursor = cursor
	FrameSizeBorder.GPI_Lib = lib
	FrameSizeBorder.GPI_DoStart=OnStart
	FrameSizeBorder.GPI_DoStop=OnStop
	FrameSizeBorder:SetScript("OnMouseDown", Lib_GPI._SizingStart)
	FrameSizeBorder:SetScript("OnMouseUp", Lib_GPI._SizingStop)
	FrameSizeBorder:SetScript("OnEnter", Lib_GPI._SizingEnter)
	FrameSizeBorder:SetScript("OnLeave", Lib_GPI._SizingLeave)
	
	return FrameSizeBorder
end
function Lib_GPI._PopupClick(self, arg1, arg2, checked)
	if type(self.value)=="table" then		
		self.value[arg1]=not checked
		if arg2 then
			arg2(self.value,arg1,checked)		
		end
	elseif type(self.value)=="function" then
		
		self.value(arg1,arg2)		
	end		
end

function Lib_GPI._PopupAddItem(self,text,checked,disabled,value,arg1,arg2)
	tinsert(self._Frame._GPIPRIVAT_Items,{["text"]=text,["checked"]=checked,["disabled"]=disabled,["value"]=value,["arg1"]=arg1,["arg2"]=arg2})
end
function Lib_GPI._PopupWipe(self)
	wipe(self._Frame._GPIPRIVAT_Items)
	if UIDROPDOWNMENU_OPEN_MENU == self._Frame then
		ToggleDropDownMenu(nil, nil, self._Frame, self._where, self._x, self._y)
	end
end

function Lib_GPI._PopupCreate(frame, level, menuList)
	if level~=1 then return end
	
	local info = UIDropDownMenu_CreateInfo()

	for i,val in ipairs(frame._GPIPRIVAT_Items) do
		info.text=val.text
		info.notCheckable = (val.checked==nil)
		info.checked = val.checked
		info.disabled=val.disabled
		info.value=val.value
		info.arg1=val.arg1
		if type(val.value)=="table" then			
			info.arg2=frame._GPIPRIVAT_TableCallback
		elseif type(val.value)=="function" then
			info.arg2=val.arg2
		end
		
		info.func=Lib_GPI._PopupClick
		UIDropDownMenu_AddButton(info)
	end
end
function Lib_GPI._PopupShow(self,where,x,y)
	if where==nil then where="cursor" end
	if UIDROPDOWNMENU_OPEN_MENU ~= self._Frame then 
		UIDropDownMenu_Initialize(self._Frame, Lib_GPI._PopupCreate, "MENU")
	end
	ToggleDropDownMenu(nil, nil, self._Frame, where, x,y)
	self._where=where
	self._x=x
	self._y=y
end

function Lib_GPI._SelectTab(self)
	local parent=self:GetParent()
	PanelTemplates_SetTab(parent,self:GetID())
	for i=1, parent.numTabs do
		parent.Tabs[i].content:Hide()
	end
	self.content:Show()	
end

function Lib_GPI.ToolBox()
	local lib={}

	function lib.SelectTab(frame,id)
		if id and frame.Tabs and frame.Tabs[id] then
			Lib_GPI._SelectTab(frame.Tabs[id])
		end
	end	
	
	function lib.AddTab(frame,name,tabFrame)
		local frameName=frame:GetName()
		frame.numTabs=frame.numTabs and frame.numTabs+1 or 1
		if frame.Tabs==nil then frame.Tabs={} end
		
		frame.Tabs[frame.numTabs]=CreateFrame("Button",frameName.."Tab"..frame.numTabs, frame, "CharacterFrameTabButtonTemplate")
		frame.Tabs[frame.numTabs]:SetID(frame.numTabs)
		frame.Tabs[frame.numTabs]:SetText(name)
		frame.Tabs[frame.numTabs]:SetScript("OnClick",Lib_GPI._SelectTab)		
		frame.Tabs[frame.numTabs].content=tabFrame
		tabFrame:Hide()
		
		if frame.numTabs==1 then
			frame.Tabs[frame.numTabs]:SetPoint("TOPLEFT",frame,"BOTTOMLEFT",5,4)
		else
			frame.Tabs[frame.numTabs]:SetPoint("TOPLEFT",frame.Tabs[frame.numTabs-1],"TOPRIGHT",-14,0)
		end
		
		Lib_GPI._SelectTab(frame.Tabs[frame.numTabs])
		Lib_GPI._SelectTab(frame.Tabs[1])
		return frame.numTabs
	end
	
	function lib.CreatePopup(TableCallback)
		local popup={}
		popup._Frame=CreateFrame("Frame", nil, UIParent, "UIDropDownMenuTemplate")
		popup._Frame._GPIPRIVAT_TableCallback=TableCallback
		popup._Frame._GPIPRIVAT_Items={}
		popup.AddItem=Lib_GPI._PopupAddItem
		popup.Show=Lib_GPI._PopupShow
		popup.Wipe=Lib_GPI._PopupWipe
		return popup
	end	

	function lib.stripChars(str)
		return string.gsub(str,"[%z\1-\127\194-\244][\128-\191]*", Lib_GPI._tableAccents)
	end
	
	function lib.CreatePattern(pattern,maximize)		
		pattern = string.gsub(pattern, "[%(%)%-%+%[%]]", "%%%1")
		if not maximize then 
			pattern = string.gsub(pattern, "%%s", "(.-)")
		else
			pattern = string.gsub(pattern, "%%s", "(.+)")
		end
		pattern = string.gsub(pattern, "%%d", "%(%%d-%)")
		if not maximize then 
			pattern = string.gsub(pattern, "%%%d%$s", "(.-)")
		else
			pattern = string.gsub(pattern, "%%%d%$s", "(.+)")
		end
		pattern = string.gsub(pattern, "%%%d$d", "%(%%d-%)")		
		--pattern = string.gsub(pattern, "%[", "%|H%(%.%-%)%[")
		--pattern = string.gsub(pattern, "%]", "%]%|h")
		return pattern
		
	end
	
	function lib.EnableSize(frame,border,path,OnStart,OnStop)
		if lib._ResizeCursor==nil then 
			lib._ResizeCursor = CreateFrame("Frame", nil, UIParent)
			lib._ResizeCursor:Hide()
			lib._ResizeCursor:SetWidth(24)
			lib._ResizeCursor:SetHeight(24)
			lib._ResizeCursor:SetFrameStrata("TOOLTIP")
			lib._ResizeCursor.Texture = lib._ResizeCursor:CreateTexture()
			lib._ResizeCursor.Texture:SetAllPoints()
			
			lib._ResizeCursor:SetScript("OnUpdate", function(self)
				  local X, Y = GetCursorPosition()
				  local Scale = self:GetEffectiveScale()
				  self:SetPoint("CENTER", UIParent, "BOTTOMLEFT", X / Scale, Y / Scale)
				end)
		end
		
		
		Lib_GPI._CreateSizeBorder(lib,frame,"BOTTOM","BOTTOMLEFT", border, border, "BOTTOMRIGHT", -border, 0,path.."Vertical.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"TOP","TOPLEFT", border, 0, "TOPRIGHT", -border, -border,path.. "Vertical.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"LEFT","TOPLEFT", 0,-border, "BOTTOMLEFT", border, border,path.. "Horizontal.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"RIGHT","TOPRIGHT",-border,-border, "BOTTOMRIGHT", 0, border,path.. "Horizontal.tga",OnStart,OnStop)
		
		Lib_GPI._CreateSizeBorder(lib,frame,"TOPLEFT","TOPLEFT", 0,0, "TOPLEFT", border, -border,path.. "Diagonal1.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"BOTTOMLEFT","BOTTOMLEFT", 0,0, "BOTTOMLEFT", border, border,path.. "Diagonal2.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"TOPRIGHT","TOPRIGHT", 0,0, "TOPRIGHT", -border, -border,path.. "Diagonal2.tga",OnStart,OnStop)
		Lib_GPI._CreateSizeBorder(lib,frame,"BOTTOMRIGHT","BOTTOMRIGHT", 0,0, "BOTTOMRIGHT", -border, border,path.. "Diagonal1.tga",OnStart,OnStop)
		
	end
	
	lib.Merge=Lib_GPI._Merge
	lib.iMerge=Lib_GPI._iMerge
	
		
	
	function lib.Combine(t,sep)
		if type(t)~="table" then return "" end
		if sep == nil then sep =" " end
		local ret=""
		for i,v in ipairs(t) do
			ret=ret..sep..v
		end
		return string.sub(ret,2)
	end
	
	function lib.Split(inputstr, sep)
		if sep == nil then
			sep = "%s"
		end
		local t={}
		for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
			if tContains(t, str)==false then
				table.insert(t, str)
			end
		end
		return t
	end
	
	lib._DataBrocker=false
	function lib:AddDataBrocker(icon,onClick,onTooltipShow,tocName,text)
		if LibStub ~= nil and self._DataBrocker ~= true then 
			local Launcher = LibStub('LibDataBroker-1.1',true)
			if Launcher ~= nil then	
				self._DataBrocker=true
				Launcher:NewDataObject(tocName, {
					type = "launcher",
					icon = icon,
					OnClick = onClick,
					OnTooltipShow = onTooltipShow,
					tocname = tocName,
					label = text,
				})
			end
		end	
	end
	
	
	return lib
end

end